#include "dict.h"

int out_size = 0;
char ** get_out = NULL;

int check_this_out(char *english)
{
  int n;
  for (n=0;n<out_size;n++)
    if (strcasecmp(english,get_out[n])==0) return n;
  return -1;
}

void load_exclude_voc(char *filename)
{
  FILE *fp;
  char buff[4096];
  char * p;
  if (filename==NULL) exit(-1);
  
  fp = fopen(filename,"rt");
  if (fp==NULL) exit(-1);
  while (fgets(buff,4096,fp)!=NULL) {
    get_out = (char **)realloc(get_out,sizeof(char*)*(out_size+1));
    p = buff;
    while (*p&&((*p>='a'&&*p<='z')||(*p>='A'&&*p<='Z'))) p++;
    *p = 0;
    get_out[out_size] = strdup(buff);
    out_size++;
  }
  fclose(fp);
}

char ** load_pages(char *settingfile)
{
  FILE * fp;
  int n = 0;
  char ** NEWTHING = NULL;
  char buff[4096];
  char * p;
  
  fp = fopen(settingfile,"rt");
  while (fgets(buff,4096,fp)!=NULL) {
    p = buff;
    while (*p&&*p!=13&&*p!=10) p++;
    *p = 0;
    if (strlen(buff)>0) {
      NEWTHING = (char**)realloc(NEWTHING,sizeof(char*)*(n+1));
      NEWTHING[n] = strdup(buff);
      n++;
    }
  }
  fclose(fp);
  NEWTHING = (char**)realloc(NEWTHING,sizeof(char*)*(n+1));
  NEWTHING[n] = NULL;
  return NEWTHING;
}

void main(void)
{
  FILE * fp;
  E2C_Dictionary DICT;
  E2C_Dictionary REF;
  int c,n,line2,w;
  char * buff;
  int size = 4096;
  int hsize = 4096;
  char * html_buff;
  int html;
  char ** exclude;
  char ** dicts;
  
  memset(&DICT,0,sizeof(E2C_Dictionary));
  memset(&REF,0,sizeof(E2C_Dictionary));

  exclude = load_pages("/etc/iome/a4c.dict.exclude");
  dicts   = load_pages("/etc/iome/a4c.dict.include");
  
  load_exclude_voc(*exclude);
  
  while (*dicts) {
    fp = fopen(*dicts,"rt");
    dict_LoadDictionary(fp,&DICT);
    fclose(fp);
    dicts++;
  }
  
  buff = (char *)malloc(size);
  html_buff = (char*)malloc(hsize);
  n = 0; line2 = 0; html=0;
  do {
    c = fgetc(stdin);
    if (c<0) c=0;
    if (html>0) {
      html_buff[html] = c;
      html++;
      if (html>=hsize) {
        hsize+=4096; /* What's the hell? */
        html_buff = (char*)realloc(html_buff,hsize);
      }
      if (c=='>')  {
        html_buff[html] = 0;
        printf("%s\n",html_buff);
        html = 0;
      }
    } else
    switch (c) {
      case '<': html = 1; html_buff[0]='<';
      case 0:
      case 10:
      case 13:
        line2++;
        if (line2<4) break;
        buff[n] = 0;
        dict_MakeReference(buff,&DICT,&REF);
        if (REF.size>0) {
          printf("%s\n\n",buff);
          printf("<br><br><!--A4C_DICT-->\n");
          for (n=0;n<REF.size;n++) 
            if (check_this_out(REF.DICT[n]->english)<0) {
              printf("%s:",REF.DICT[n]->english);
              for (w=0;w<REF.DICT[n]->size;w++)
                printf(" %s",REF.DICT[n]->chinese[w]);
              printf("\n<br>\n");
            }
          printf("<br><br>\n<!--A4C_DICT-->\n");
          if (REF.size>0) free(REF.DICT);
          memset(&REF,0,sizeof(REF));
        }
        n = 0; line2 = 0;
      break;
      default:
        line2 = 0;
        buff[n] = (char)c;
        n++;
        if (n>=size) {
          size+=4096;
          buff = (char *)realloc(buff,size);
        }
    }
  } while (c!=0);
  
}
